/*
  SKILLS : HEADER FILE
  
  Passing skills: 
    find best teammate to pass ball to him
    pass the ball

  Mehran Motamed
  Ehsan Foroughi 
  ParsAI Team
  Sharif University of Tech.

 */

#ifndef _SKILLS_PASS_H
#define _SKILLS_PASS_H

#ifndef _skills_pass_extern_
#define _skills_pass_extern_ extern
#endif

#include "../headers.h"

#include "skills.h"

class c_pass: public c_base_skill
{
 public:
  void update_bytime(void);
  bool possible(void);
  double weight(void);
  void perform(void);

  int goaler_pass(double &gx, double &dy);
 protected:
  
  void calculate(void);
  double position_in_field_value(int num);
  double position_value(int num);
  double safeness_value(int num, double sx, double sy);
  double backpass_value(int num);
  double forepass_value(int num);
  int best_pass_target(void);

  int c_pass::search_pass_value(double kpower, double kdir, double &reachspeed);
//  int search_pass_value(double kpower, double kdir);
  void search_pass(void);

  Command com2send;
  double value;
  int dest_player;
  bool canpass;
 
  bool calculated;
};

_skills_pass_extern_ c_pass pass;

#endif
