#define _behavior_stand_extern_
#include "stand.h"

//#define STAND_FIRM_STRICT

double goaler_stand_pos_x(void)
{
  return (-52+GOALER_STAND_RAD*cos(atan2(estimate_ball_y(1)-world.body.loc.y,estimate_ball_x(1)-world.body.loc.x)));
//  return (-52+GOALER_STAND_RAD*cos(atan2(world.ball.y,world.ball.x+52)));
/*  double dir1, dir2, dir, iy, ret;
  
  dir1 = direction(-GOAL_X-world.ball.x,GOAL_HIGH_Y-world.ball.y);
  dir2 = direction(-GOAL_X-world.ball.x,GOAL_LOW_Y-world.ball.y);
  if (dir1<0) dir1 += 360;
  if (dir2<0) dir2 += 360;
  dir = normalize_angle((dir1+dir2)/2);
 
  ret = -GOAL_X-GOALER_STAND_RAD*cos(Deg2Rad(dir));

  return ret;*/
}

double goaler_stand_pos_y(void)
{
  return (GOALER_STAND_RAD*sin(atan2(estimate_ball_y(1)-world.body.loc.y,estimate_ball_x(1)-world.body.loc.x)));
//  return (GOALER_STAND_RAD*sin(atan2(world.ball.y,world.ball.x+52)));
/*  double dir1, dir2, dir, iy, ret;
  
  dir1 = direction(-GOAL_X-world.ball.x,GOAL_HIGH_Y-world.ball.y);
  dir2 = direction(-GOAL_X-world.ball.x,GOAL_LOW_Y-world.ball.y);
  if (dir1<0) dir1 += 360;
  if (dir2<0) dir2 += 360;
  dir = normalize_angle((dir1+dir2)/2);
  
  iy = world.ball.y + tan(Deg2Rad(dir))*(-GOAL_X-world.ball.x);
  
  ret = iy-GOALER_STAND_RAD*sin(Deg2Rad(dir));

  return ret;*/
}

double player_stand_pos_x(void)
{
  double t = ((world.ball.x+FIELD_LENGTH/2)/FIELD_LENGTH);
  t = (double)((int)(t*INTERPOLATION))/INTERPOLATION;
  t = (t*arrange.play_positions[player.unum][3][0])+((1-t)*arrange.play_positions[player.unum][2][0]);
/*  // Pooya
  if (client.role==DEFEND && world.ball.x<-35 && world.ball.x>-PENALTY_CORNER_X && dist(world.tmate[1].x-world.ball.x,world.tmate[1].y-world.ball.y)>3.0)
    if (world.ball.x-2<t) t=world.ball.x-2;
  if (client.role==MIDDLE && world.ball.x>26)
    if(world.ball.x-5>t) t=world.ball.x-5;
  if (client.role==ATTACK && world.ball.x>20) 
    t=world.ball.x+5;*/
#ifdef STAND_FIRM_STRICT
  if ((client.role==DEFEND)&&(world.ball.x>5)&&(player.unum!=4)) t += ((world.ball.x/FIELD_LENGTH+0.7)*25);
  else if (client.role==MIDDLE) t += (world.ball.x/FIELD_LENGTH+0.7)*12;
  if ((player.unum==4)&&(world.ball.x<0)) t = -33.5;
  if ((player.unum==4)&&(world.ball.x<0)) t = (-52+20*cos(atan2(world.ball.y,world.ball.x+52)));
  t = (t-world.ball.x)*0.7 + world.ball.x;
#endif
  if (t>(world.offside.opp.line-OFFSIDE_CARE_RANGE) && world.ball.x<world.offside.opp.line) t = world.offside.opp.line-OFFSIDE_CARE_RANGE;

  return (t);
}

double player_stand_pos_y(void)
{
  double t = ((world.ball.x+FIELD_LENGTH/2)/FIELD_LENGTH);
  t = (double)((int)(t*INTERPOLATION))/INTERPOLATION;
  t = (t*arrange.play_positions[player.unum][3][1])+((1-t)*arrange.play_positions[player.unum][2][1]);
#ifdef STAND_FIRM_STRICT
  t += (world.ball.x/FIELD_LENGTH+0.6)*6;
  if ((player.unum==4)&&(world.ball.x<0)) t = 18*world.ball.y/fabs(-GOAL_X-world.ball.x);
  t = (t-world.ball.y)*0.7 + world.ball.y;
  if ((player.unum==4)&&(world.ball.x<0)) t = 20*sin(atan2(world.ball.y,world.ball.x+52));
#endif
  return (t);
}

double stand_pos_x(void)
{
  if (client.role==GOALER)
    return goaler_stand_pos_x();
  else return player_stand_pos_x();
}

double stand_pos_y(void)
{
  if (client.role==GOALER)
    return goaler_stand_pos_y();
  else return player_stand_pos_y();
}

bool ball_in_region(void)
{
  return((arrange.play_positions[player.unum][0][0]<world.ball.x)&&(world.ball.x<arrange.play_positions[player.unum][1][0])&&
         (arrange.play_positions[player.unum][0][1]<world.ball.y)&&(world.ball.y<arrange.play_positions[player.unum][1][1]));
}

bool ball_in_region(int unum)
{
  return((arrange.play_positions[unum][0][0]<world.ball.x)&&(world.ball.x<arrange.play_positions[unum][1][0])&&
         (arrange.play_positions[unum][0][1]<world.ball.y)&&(world.ball.y<arrange.play_positions[unum][1][1]));
}


bool in_region(double x, double y)
{
  return((arrange.play_positions[player.unum][0][0]<x)&&(x<arrange.play_positions[player.unum][1][0])&&
         (arrange.play_positions[player.unum][0][1]<y)&&(y<arrange.play_positions[player.unum][1][1]));
}
